diff --git a/usr/src/nvidia-535.129.03-orig/nvidia/nv-pci.c b/./nvidia/nv-pci.c
index 326833e..74ac5c7 100644
--- a/usr/src/nvidia-535.129.03-orig/nvidia/nv-pci.c
+++ b/./nvidia/nv-pci.c
@@ -31,6 +31,7 @@
 
 #if defined(NV_VGPU_KVM_BUILD)
 #include "nv-vgpu-vfio-interface.h"
+#include <linux/iommu.h> /** iommu_present */
 #endif
 
 #if defined(NV_SEQ_READ_ITER_PRESENT)
@@ -212,7 +213,8 @@ nv_pci_probe
             goto failed;
         }
 
-        if (pci_dev->dev.bus->iommu_ops == NULL) 
+        //if (pci_dev->dev.bus->iommu_ops == NULL) 
+        if(!iommu_present(pci_dev->dev.bus))
         {
             nv = NV_STATE_PTR(nvl);
             if (rm_is_iommu_needed_for_sriov(sp, nv))
diff --git a/usr/src/nvidia-535.129.03-orig/nvidia-drm/nvidia-drm-drv.c b/./nvidia-drm/nvidia-drm-drv.c
index 6c68d82..6044b8f 100644
--- a/usr/src/nvidia-535.129.03-orig/nvidia-drm/nvidia-drm-drv.c
+++ b/./nvidia-drm/nvidia-drm-drv.c
@@ -1287,29 +1287,29 @@ static const struct drm_ioctl_desc nv_drm_ioctls[] = {
 #if defined(NV_DRM_ATOMIC_MODESET_AVAILABLE)
     DRM_IOCTL_DEF_DRV(NVIDIA_GEM_IMPORT_NVKMS_MEMORY,
                       nv_drm_gem_import_nvkms_memory_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
 #endif /* NV_DRM_ATOMIC_MODESET_AVAILABLE */
 
     DRM_IOCTL_DEF_DRV(NVIDIA_GEM_IMPORT_USERSPACE_MEMORY,
                       nv_drm_gem_import_userspace_memory_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GEM_MAP_OFFSET,
                       nv_drm_gem_map_offset_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GET_DEV_INFO,
                       nv_drm_get_dev_info_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
 
 #if defined(NV_DRM_FENCE_AVAILABLE)
     DRM_IOCTL_DEF_DRV(NVIDIA_FENCE_SUPPORTED,
                       nv_drm_fence_supported_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_PRIME_FENCE_CONTEXT_CREATE,
                       nv_drm_prime_fence_context_create_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GEM_PRIME_FENCE_ATTACH,
                       nv_drm_gem_prime_fence_attach_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
 #endif
 
     DRM_IOCTL_DEF_DRV(NVIDIA_GET_CLIENT_CAPABILITY,
@@ -1318,37 +1318,37 @@ static const struct drm_ioctl_desc nv_drm_ioctls[] = {
 #if defined(NV_DRM_ATOMIC_MODESET_AVAILABLE)
     DRM_IOCTL_DEF_DRV(NVIDIA_GET_CRTC_CRC32,
                       nv_drm_get_crtc_crc32_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GET_CRTC_CRC32_V2,
                       nv_drm_get_crtc_crc32_v2_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GEM_EXPORT_NVKMS_MEMORY,
                       nv_drm_gem_export_nvkms_memory_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GEM_ALLOC_NVKMS_MEMORY,
                       nv_drm_gem_alloc_nvkms_memory_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GEM_EXPORT_DMABUF_MEMORY,
                       nv_drm_gem_export_dmabuf_memory_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GEM_IDENTIFY_OBJECT,
                       nv_drm_gem_identify_object_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_DMABUF_SUPPORTED,
                       nv_drm_dmabuf_supported_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GET_DPY_ID_FOR_CONNECTOR_ID,
                       nv_drm_get_dpy_id_for_connector_id_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GET_CONNECTOR_ID_FOR_DPY_ID,
                       nv_drm_get_connector_id_for_dpy_id_ioctl,
-                      DRM_RENDER_ALLOW|DRM_UNLOCKED),
+                      DRM_RENDER_ALLOW),
     DRM_IOCTL_DEF_DRV(NVIDIA_GRANT_PERMISSIONS,
                       nv_drm_grant_permission_ioctl,
-                      DRM_UNLOCKED|DRM_MASTER),
+                      DRM_MASTER),
     DRM_IOCTL_DEF_DRV(NVIDIA_REVOKE_PERMISSIONS,
                       nv_drm_revoke_permission_ioctl,
-                      DRM_UNLOCKED|DRM_MASTER),
+                      DRM_MASTER),
 #endif /* NV_DRM_ATOMIC_MODESET_AVAILABLE */
 };
 
diff --git a/usr/src/nvidia-535.129.03-orig/nvidia-vgpu-vfio/nvidia-vgpu-vfio.c b/./nvidia-vgpu-vfio/nvidia-vgpu-vfio.c
index a2620f6..b1f434f 100644
--- a/usr/src/nvidia-535.129.03-orig/nvidia-vgpu-vfio/nvidia-vgpu-vfio.c
+++ b/./nvidia-vgpu-vfio/nvidia-vgpu-vfio.c
@@ -2872,7 +2872,7 @@ static irqreturn_t vgpu_msix_handler(int irq, void *arg)
     }
 
     if (trigger != NULL)
-        eventfd_signal(trigger, 1);
+        eventfd_signal(trigger);
     else
         return IRQ_NONE;
 
@@ -3185,7 +3185,7 @@ NV_STATUS nv_vgpu_inject_interrupt(void *vgpuRef)
     }
     NV_SPIN_UNLOCK_IRQRESTORE(&vgpu_dev->intr_info_lock, eflags);
 
-    eventfd_signal(trigger, 1);
+    eventfd_signal(trigger);
 
     return status;
 }
